use ctor::{ctor, dtor};

#[ctor]
unsafe fn ctor() {
    println!("Hello from ctor");
}

#[dtor]
unsafe fn dtor() {
    println!("Goodbye from ctor");
}

ctor_lite::ctor! {
    unsafe fn ctor_lite() {
        println!("Hello from ctor_lite");
    }
}

ctor_lite::dtor! {
    unsafe fn dtor_lite() {
        println!("Goodbye from ctor_lite");
    }
}

struct HelloPrinter;

impl HelloPrinter {
    pub fn print(self) {
        println!("Hello from printer");
    }
}

impl Drop for HelloPrinter {
    fn drop(&mut self) {
        println!("Goodbye from printer");
    }
}

fn main() {
    println!("Hello from main");
    let printer = HelloPrinter;
    printer.print();
}
